<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Building blocks for deserializing basic values using the `IntoDeserializer` trait."><meta name="keywords" content="rust, rustlang, rust-lang, value"><title>serde::de::value - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc mod"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../serde/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../serde/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"><a href="#">Module value</a></h2><div class="sidebar-elems"><section><div class="block"><ul><li><a href="#structs">Structs</a></li></ul></div></section></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../serde/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Module <a href="../../index.html">serde</a>::<wbr><a href="../index.html">de</a>::<wbr><a class="mod" href="#">value</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../../../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../../../src/serde/de/value.rs.html#1-1679">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>Building blocks for deserializing basic values using the <code>IntoDeserializer</code>
trait.</p>

<div class='information'><div class='tooltip edition' data-edition="2018">ⓘ</div></div><div class="example-wrap"><pre class="rust rust-example-rendered edition"><code><span class="kw">use</span> <span class="ident">std::str::FromStr</span>;
<span class="kw">use</span> <span class="ident">serde::Deserialize</span>;
<span class="kw">use</span> <span class="ident">serde::de</span>::{<span class="ident">value</span>, <span class="ident">IntoDeserializer</span>};

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Deserialize</span>)]</span>
<span class="kw">enum</span> <span class="ident">Setting</span> {
    <span class="ident">On</span>,
    <span class="ident">Off</span>,
}

<span class="kw">impl</span> <span class="ident">FromStr</span> <span class="kw">for</span> <span class="ident">Setting</span> {
    <span class="kw">type</span> <span class="prelude-val">Err</span> <span class="op">=</span> <span class="ident">value::Error</span>;

    <span class="kw">fn</span> <span class="ident">from_str</span>(<span class="ident">s</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span>, <span class="ident"><span class="self">Self</span>::Err</span><span class="op">&gt;</span> {
        <span class="ident"><span class="self">Self</span>::deserialize</span>(<span class="ident">s</span>.<span class="ident">into_deserializer</span>())
    }
}</code></pre></div>
</div></details><h2 id="structs" class="small-section-header"><a href="#structs">Structs</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.BoolDeserializer.html" title="serde::de::value::BoolDeserializer struct">BoolDeserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding
a <code>bool</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.BorrowedBytesDeserializer.html" title="serde::de::value::BorrowedBytesDeserializer struct">BorrowedBytesDeserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding a <code>&amp;[u8]</code> with a lifetime tied to another
deserializer. Always calls <a href="../trait.Visitor.html#method.visit_borrowed_bytes" title="Visitor::visit_borrowed_bytes"><code>Visitor::visit_borrowed_bytes</code></a>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.BorrowedStrDeserializer.html" title="serde::de::value::BorrowedStrDeserializer struct">BorrowedStrDeserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding a <code>&amp;str</code> with a lifetime tied to another
deserializer.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.BytesDeserializer.html" title="serde::de::value::BytesDeserializer struct">BytesDeserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding a <code>&amp;[u8]</code>. Always calls <a href="../trait.Visitor.html#method.visit_bytes" title="Visitor::visit_bytes"><code>Visitor::visit_bytes</code></a>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.CharDeserializer.html" title="serde::de::value::CharDeserializer struct">CharDeserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding
a <code>char</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.CowStrDeserializer.html" title="serde::de::value::CowStrDeserializer struct">CowStrDeserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding a <code>Cow&lt;str&gt;</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Error.html" title="serde::de::value::Error struct">Error</a></div><div class="item-right docblock-short"><p>A minimal representation of all possible errors that can occur using the
<code>IntoDeserializer</code> trait.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.F32Deserializer.html" title="serde::de::value::F32Deserializer struct">F32Deserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding
an <code>f32</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.F64Deserializer.html" title="serde::de::value::F64Deserializer struct">F64Deserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding
an <code>f64</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.I8Deserializer.html" title="serde::de::value::I8Deserializer struct">I8Deserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding
an <code>i8</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.I16Deserializer.html" title="serde::de::value::I16Deserializer struct">I16Deserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding
an <code>i16</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.I32Deserializer.html" title="serde::de::value::I32Deserializer struct">I32Deserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding
an <code>i32</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.I64Deserializer.html" title="serde::de::value::I64Deserializer struct">I64Deserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding
an <code>i64</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.I128Deserializer.html" title="serde::de::value::I128Deserializer struct">I128Deserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding
an <code>i128</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.IsizeDeserializer.html" title="serde::de::value::IsizeDeserializer struct">IsizeDeserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding
an <code>isize</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.MapAccessDeserializer.html" title="serde::de::value::MapAccessDeserializer struct">MapAccessDeserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding a <code>MapAccess</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.MapDeserializer.html" title="serde::de::value::MapDeserializer struct">MapDeserializer</a></div><div class="item-right docblock-short"><p>A deserializer that iterates over a map.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.SeqAccessDeserializer.html" title="serde::de::value::SeqAccessDeserializer struct">SeqAccessDeserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding a <code>SeqAccess</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.SeqDeserializer.html" title="serde::de::value::SeqDeserializer struct">SeqDeserializer</a></div><div class="item-right docblock-short"><p>A deserializer that iterates over a sequence.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.StrDeserializer.html" title="serde::de::value::StrDeserializer struct">StrDeserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding a <code>&amp;str</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.StringDeserializer.html" title="serde::de::value::StringDeserializer struct">StringDeserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding a <code>String</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.U8Deserializer.html" title="serde::de::value::U8Deserializer struct">U8Deserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding
a <code>u8</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.U16Deserializer.html" title="serde::de::value::U16Deserializer struct">U16Deserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding
a <code>u16</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.U32Deserializer.html" title="serde::de::value::U32Deserializer struct">U32Deserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding a <code>u32</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.U64Deserializer.html" title="serde::de::value::U64Deserializer struct">U64Deserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding
a <code>u64</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.U128Deserializer.html" title="serde::de::value::U128Deserializer struct">U128Deserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding
a <code>u128</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.UnitDeserializer.html" title="serde::de::value::UnitDeserializer struct">UnitDeserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding a <code>()</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.UsizeDeserializer.html" title="serde::de::value::UsizeDeserializer struct">UsizeDeserializer</a></div><div class="item-right docblock-short"><p>A deserializer holding
a <code>usize</code>.</p>
</div></div></div></section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="serde" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>